from dataclasses import dataclass

from webcommander.sdlize.wc_base_dto import WCBaseDTO


@dataclass(kw_only=True)
class CommonSettingsFieldsDTO(WCBaseDTO):
    configKey: str = None
    value: str = None


@dataclass(kw_only=True)
class SettingsDataDTO(WCBaseDTO):
    customerProfilePage: list[CommonSettingsFieldsDTO] = None
    awsS3: list[CommonSettingsFieldsDTO] = None
    cloudStorage: list[CommonSettingsFieldsDTO] = None
    administration: list[CommonSettingsFieldsDTO] = None
    eCommerce: list[CommonSettingsFieldsDTO] = None
    webtool: list[CommonSettingsFieldsDTO] = None
    googleEventTracking: list[CommonSettingsFieldsDTO] = None
    frontendPages: list[CommonSettingsFieldsDTO] = None
    searchPage: list[CommonSettingsFieldsDTO] = None
    relatedProduct: list[CommonSettingsFieldsDTO] = None
    similarProduct: list[CommonSettingsFieldsDTO] = None
    customerLogin: list[CommonSettingsFieldsDTO] = None
    customerRegistration: list[CommonSettingsFieldsDTO] = None
    customerRegistrationField: list[CommonSettingsFieldsDTO] = None
    customerAccountInformation: list[CommonSettingsFieldsDTO] = None
    billingAddressField: list[CommonSettingsFieldsDTO] = None
    shippingAddressField: list[CommonSettingsFieldsDTO] = None
    email: list[CommonSettingsFieldsDTO] = None
    locale: list[CommonSettingsFieldsDTO] = None
    responsive: list[CommonSettingsFieldsDTO] = None
    dashboardType: list[CommonSettingsFieldsDTO] = None
    general: list[CommonSettingsFieldsDTO] = None
    product: list[CommonSettingsFieldsDTO] = None
    productImage: list[CommonSettingsFieldsDTO] = None
    categoryImage: list[CommonSettingsFieldsDTO] = None
    currency: list[CommonSettingsFieldsDTO] = None
    seoConfig: list[CommonSettingsFieldsDTO] = None
    tax: list[CommonSettingsFieldsDTO] = None
    cartPage: list[CommonSettingsFieldsDTO] = None
    checkoutPage: list[CommonSettingsFieldsDTO] = None
    advanceCheckoutPage: list[CommonSettingsFieldsDTO] = None
    orderPrintAndEmail: list[CommonSettingsFieldsDTO] = None
    shipping: list[CommonSettingsFieldsDTO] = None
    categoryPage: list[CommonSettingsFieldsDTO] = None
    overview: list[CommonSettingsFieldsDTO] = None
    manageMyAccount: list[CommonSettingsFieldsDTO] = None
    getStartedWizard: list[CommonSettingsFieldsDTO] = None
    license: list[CommonSettingsFieldsDTO] = None
    storeCredit: list[CommonSettingsFieldsDTO] = None
    productProperties: list[CommonSettingsFieldsDTO] = None
    myAccountPage: list[CommonSettingsFieldsDTO] = None
    myEntitlements: list[CommonSettingsFieldsDTO] = None
    myOrders: list[CommonSettingsFieldsDTO] = None
    assignToCustomer: list[CommonSettingsFieldsDTO] = None
    debugLevel: list[CommonSettingsFieldsDTO] = None
    elasticSearch: list[CommonSettingsFieldsDTO] = None
    taxjar: list[CommonSettingsFieldsDTO] = None
    acpAllowedDeliveryType: list[CommonSettingsFieldsDTO] = None
    bdpAllowedDeliveryType: list[CommonSettingsFieldsDTO] = None
    chqAllowedDeliveryType: list[CommonSettingsFieldsDTO] = None
    morAllowedDeliveryType: list[CommonSettingsFieldsDTO] = None
    pisAllowedDeliveryType: list[CommonSettingsFieldsDTO] = None
    scrAllowedDeliveryType: list[CommonSettingsFieldsDTO] = None
    seProductColumnConfig: list[CommonSettingsFieldsDTO] = None
    seCategoryColumnConfig: list[CommonSettingsFieldsDTO] = None
    seOrderColumnConfig: list[CommonSettingsFieldsDTO] = None
    seCustomerColumnConfig: list[CommonSettingsFieldsDTO] = None
    seCustomerGroupColumnConfig: list[CommonSettingsFieldsDTO] = None
    managementHub: list[CommonSettingsFieldsDTO] = None
    loyaltyPoint: list[CommonSettingsFieldsDTO] = None
    referboard: list[CommonSettingsFieldsDTO] = None
    reviewRating: list[CommonSettingsFieldsDTO] = None
    shipBob: list[CommonSettingsFieldsDTO] = None
    youtube: list[CommonSettingsFieldsDTO] = None
    myob: list[CommonSettingsFieldsDTO] = None
    googleTrustedStore: list[CommonSettingsFieldsDTO] = None
    customerCanvas: list[CommonSettingsFieldsDTO] = None
    customizeProductDesign: list[CommonSettingsFieldsDTO] = None
    cartSurcharge: list[CommonSettingsFieldsDTO] = None
    mailChimp: list[CommonSettingsFieldsDTO] = None
    compareProduct: list[CommonSettingsFieldsDTO] = None
    resolutionCenter: list[CommonSettingsFieldsDTO] = None
    popup: list[CommonSettingsFieldsDTO] = None
    multiLevelPricing: list[CommonSettingsFieldsDTO] = None
    myLists: list[CommonSettingsFieldsDTO] = None
    giftRegistry: list[CommonSettingsFieldsDTO] = None
    discount: list[CommonSettingsFieldsDTO] = None
    askQuestion: list[CommonSettingsFieldsDTO] = None
    quote: list[CommonSettingsFieldsDTO] = None
    appointment: list[CommonSettingsFieldsDTO] = None
    filterPage: list[CommonSettingsFieldsDTO] = None
    filterGroupPage: list[CommonSettingsFieldsDTO] = None
    productQuickView: list[CommonSettingsFieldsDTO] = None
    amazon: list[CommonSettingsFieldsDTO] = None
    googleProduct: list[CommonSettingsFieldsDTO] = None
    locationWidgetDefaultAddress: list[CommonSettingsFieldsDTO] = None
    sendle: list[CommonSettingsFieldsDTO] = None
    liveChat: list[CommonSettingsFieldsDTO] = None
    donations: list[CommonSettingsFieldsDTO] = None
    donation: list[CommonSettingsFieldsDTO] = None
    preorder: list[CommonSettingsFieldsDTO] = None
    routific: list[CommonSettingsFieldsDTO] = None
    googleAnalytics: list[CommonSettingsFieldsDTO] = None
    googleMap: list[CommonSettingsFieldsDTO] = None
    manageContact: list[CommonSettingsFieldsDTO] = None
    starTrack: list[CommonSettingsFieldsDTO] = None
    zendesk: list[CommonSettingsFieldsDTO] = None
    productTax: list[CommonSettingsFieldsDTO] = None
    productTaxOverwriteDefault52: list[CommonSettingsFieldsDTO] = None
    productTaxOverwriteDefault103: list[CommonSettingsFieldsDTO] = None
    productTaxOverwriteDefault94: list[CommonSettingsFieldsDTO] = None
    categoryTax: list[CommonSettingsFieldsDTO] = None
    categoryTaxOverwriteDefault19: list[CommonSettingsFieldsDTO] = None
    shippingTax: list[CommonSettingsFieldsDTO] = None
    orderTax: list[CommonSettingsFieldsDTO] = None
    myCarts: list[CommonSettingsFieldsDTO] = None
    abandonedCart: list[CommonSettingsFieldsDTO] = None
    saveCart: list[CommonSettingsFieldsDTO] = None
    awaitingPayment: list[CommonSettingsFieldsDTO] = None
    giftCard: list[CommonSettingsFieldsDTO] = None
    productImageSwapping: list[CommonSettingsFieldsDTO] = None
    blog: list[CommonSettingsFieldsDTO] = None
    wishList: list[CommonSettingsFieldsDTO] = None
    square: list[CommonSettingsFieldsDTO] = None
    productPage: list[CommonSettingsFieldsDTO] = None
    eventSessionSetting: list[CommonSettingsFieldsDTO] = None
    ebayListing: list[CommonSettingsFieldsDTO] = None
    giftWrapper: list[CommonSettingsFieldsDTO] = None
    cache: list[CommonSettingsFieldsDTO] = None
    megaMenuEmbeddedPage: list[CommonSettingsFieldsDTO] = None
    frontendPaymentGatewaysView: list[CommonSettingsFieldsDTO] = None
    pageCss: list[CommonSettingsFieldsDTO] = None
    templateFile: list[CommonSettingsFieldsDTO] = None


@dataclass(kw_only=True)
class SettingsListDTO(WCBaseDTO):
    settings: SettingsDataDTO = None
